<?php
/**
 * Safha One Page: Customizer
 */

/**
 * Add postMessage support for site title and description for the Theme Customizer.
 *
 * @param WP_Customize_Manager $wp_customize Theme Customizer object.
 */

function safha_one_page_custom_controls() {

	load_template( trailingslashit( get_template_directory() ) . '/inc/custom-control.php' );
}

add_action( 'customize_register', 'safha_one_page_custom_controls' );

function safha_one_page_customize_register( $wp_customize ) {

	load_template( trailingslashit( get_template_directory() ) . '/inc/icon-changer.php' );
	
	$wp_customize->add_panel( 'safha_one_page_panel_id', array(
	    'priority' => 10,
	    'capability' => 'edit_theme_options',
	    'theme_supports' => '',
	    'title' => __( 'Theme Settings', 'safha-one-page' ),
	    'description' => __( 'Description of what this panel does.', 'safha-one-page' ),
	) );

	// font array
	$safha_one_page_font_array = array(
        '' => 'No Fonts',
        'Abril Fatface' => 'Abril Fatface',
        'Acme' => 'Acme',
        'Anton' => 'Anton',
        'Architects Daughter' => 'Architects Daughter',
        'Arimo' => 'Arimo',
        'Arsenal' => 'Arsenal', 
        'Arvo' => 'Arvo',
        'Alegreya' => 'Alegreya',
        'Alfa Slab One' => 'Alfa Slab One',
        'Averia Serif Libre' => 'Averia Serif Libre',
        'Bangers' => 'Bangers', 
        'Boogaloo' => 'Boogaloo',
        'Bad Script' => 'Bad Script',
        'Bitter' => 'Bitter',
        'Bree Serif' => 'Bree Serif',
        'BenchNine' => 'BenchNine', 
        'Cabin' => 'Cabin', 
        'Cardo' => 'Cardo',
        'Courgette' => 'Courgette',
        'Cherry Swash' => 'Cherry Swash',
        'Cormorant Garamond' => 'Cormorant Garamond',
        'Crimson Text' => 'Crimson Text',
        'Cuprum' => 'Cuprum', 
        'Cookie' => 'Cookie', 
        'Chewy' => 'Chewy', 
        'Days One' => 'Days One', 
        'Dosis' => 'Dosis',
        'Droid Sans' => 'Droid Sans',
        'Economica' => 'Economica',
        'Fredoka One' => 'Fredoka One',
        'Fjalla One' => 'Fjalla One',
        'Francois One' => 'Francois One',
        'Frank Ruhl Libre' => 'Frank Ruhl Libre',
        'Gloria Hallelujah' => 'Gloria Hallelujah',
        'Great Vibes' => 'Great Vibes',
        'Handlee' => 'Handlee', 
        'Hammersmith One' => 'Hammersmith One',
        'Inconsolata' => 'Inconsolata', 
        'Indie Flower' => 'Indie Flower', 
        'IM Fell English SC' => 'IM Fell English SC', 
        'Julius Sans One' => 'Julius Sans One',
        'Josefin Slab' => 'Josefin Slab', 
        'Josefin Sans' => 'Josefin Sans', 
        'Kanit' => 'Kanit', 
        'Lobster' => 'Lobster', 
        'Lato' => 'Lato',
        'Lora' => 'Lora', 
        'Libre Baskerville' =>'Libre Baskerville',
        'Lobster Two' => 'Lobster Two',
        'Merriweather' =>'Merriweather', 
        'Monda' => 'Monda',
        'Montserrat' => 'Montserrat',
        'Muli' => 'Muli', 
        'Marck Script' => 'Marck Script',
        'Noto Serif' => 'Noto Serif',
        'Open Sans' => 'Open Sans', 
        'Overpass' => 'Overpass',
        'Overpass Mono' => 'Overpass Mono',
        'Oxygen' => 'Oxygen', 
        'Orbitron' => 'Orbitron', 
        'Patua One' => 'Patua One', 
        'Pacifico' => 'Pacifico',
        'Padauk' => 'Padauk', 
        'Playball' => 'Playball',
        'Playfair Display' => 'Playfair Display', 
        'PT Sans' => 'PT Sans',
        'Philosopher' => 'Philosopher',
        'Permanent Marker' => 'Permanent Marker',
        'Poiret One' => 'Poiret One', 
        'Quicksand' => 'Quicksand', 
        'Quattrocento Sans' => 'Quattrocento Sans', 
        'Raleway' => 'Raleway', 
        'Rubik' => 'Rubik', 
        'Rokkitt' => 'Rokkitt', 
        'Russo One' => 'Russo One', 
        'Righteous' => 'Righteous', 
        'Slabo' => 'Slabo', 
        'Source Sans Pro' => 'Source Sans Pro', 
        'Shadows Into Light Two' =>'Shadows Into Light Two', 
        'Shadows Into Light' => 'Shadows Into Light', 
        'Sacramento' => 'Sacramento', 
        'Shrikhand' => 'Shrikhand', 
        'Tangerine' => 'Tangerine',
        'Ubuntu' => 'Ubuntu', 
        'VT323' => 'VT323', 
        'Varela Round' => 'Varela Round', 
        'Vampiro One' => 'Vampiro One',
        'Vollkorn' => 'Vollkorn',
        'Volkhov' => 'Volkhov', 
        'Yanone Kaffeesatz' => 'Yanone Kaffeesatz',
    );
    
	//Typography
	$wp_customize->add_section( 'safha_one_page_typography', array(
    	'title'      => __( 'Color / Fonts Settings', 'safha-one-page' ),
		'priority'   => 30,
		'panel' => 'safha_one_page_panel_id'
	) );
	
	// This is Paragraph Color picker setting
	$wp_customize->add_setting( 'safha_one_page_paragraph_color', array(
		'default' => '',
		'sanitize_callback'	=> 'sanitize_hex_color'
	));
	$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'safha_one_page_paragraph_color', array(
		'label' => __('Paragraph Color', 'safha-one-page'),
		'section' => 'safha_one_page_typography',
		'settings' => 'safha_one_page_paragraph_color',
	)));

	//This is Paragraph FontFamily picker setting
	$wp_customize->add_setting('safha_one_page_paragraph_font_family',array(
	  'default' => '',
	  'capability' => 'edit_theme_options',
	  'sanitize_callback' => 'safha_one_page_sanitize_choices'
	));
	$wp_customize->add_control(
	    'safha_one_page_paragraph_font_family', array(
	    'section'  => 'safha_one_page_typography',
	    'label'    => __( 'Paragraph Fonts','safha-one-page'),
	    'type'     => 'select',
	    'choices'  => $safha_one_page_font_array,
	));

	$wp_customize->add_setting('safha_one_page_paragraph_font_size',array(
		'default'	=> '',
		'sanitize_callback'	=> 'sanitize_text_field'
	));
	$wp_customize->add_control('safha_one_page_paragraph_font_size',array(
		'label'	=> __('Paragraph Font Size','safha-one-page'),
		'section'	=> 'safha_one_page_typography',
		'setting'	=> 'safha_one_page_paragraph_font_size',
		'type'	=> 'text'
	));

	// This is "a" Tag Color picker setting
	$wp_customize->add_setting( 'safha_one_page_atag_color', array(
		'default' => '',
		'sanitize_callback'	=> 'sanitize_hex_color'
	));
	$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'safha_one_page_atag_color', array(
		'label' => __('"a" Tag Color', 'safha-one-page'),
		'section' => 'safha_one_page_typography',
		'settings' => 'safha_one_page_atag_color',
	)));

	//This is "a" Tag FontFamily picker setting
	$wp_customize->add_setting('safha_one_page_atag_font_family',array(
	  'default' => '',
	  'capability' => 'edit_theme_options',
	  'sanitize_callback' => 'safha_one_page_sanitize_choices'
	));
	$wp_customize->add_control(
	    'safha_one_page_atag_font_family', array(
	    'section'  => 'safha_one_page_typography',
	    'label'    => __( '"a" Tag Fonts','safha-one-page'),
	    'type'     => 'select',
	    'choices'  => $safha_one_page_font_array,
	));

	// This is "a" Tag Color picker setting
	$wp_customize->add_setting( 'safha_one_page_li_color', array(
		'default' => '',
		'sanitize_callback'	=> 'sanitize_hex_color'
	));
	$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'safha_one_page_li_color', array(
		'label' => __('"li" Tag Color', 'safha-one-page'),
		'section' => 'safha_one_page_typography',
		'settings' => 'safha_one_page_li_color',
	)));

	//This is "li" Tag FontFamily picker setting
	$wp_customize->add_setting('safha_one_page_li_font_family',array(
	  'default' => '',
	  'capability' => 'edit_theme_options',
	  'sanitize_callback' => 'safha_one_page_sanitize_choices'
	));
	$wp_customize->add_control(
	    'safha_one_page_li_font_family', array(
	    'section'  => 'safha_one_page_typography',
	    'label'    => __( '"li" Tag Fonts','safha-one-page'),
	    'type'     => 'select',
	    'choices'  => $safha_one_page_font_array,
	));

	// This is H1 Color picker setting
	$wp_customize->add_setting( 'safha_one_page_h1_color', array(
		'default' => '',
		'sanitize_callback'	=> 'sanitize_hex_color'
	));
	$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'safha_one_page_h1_color', array(
		'label' => __('H1 Color', 'safha-one-page'),
		'section' => 'safha_one_page_typography',
		'settings' => 'safha_one_page_h1_color',
	)));

	//This is H1 FontFamily picker setting
	$wp_customize->add_setting('safha_one_page_h1_font_family',array(
	  'default' => '',
	  'capability' => 'edit_theme_options',
	  'sanitize_callback' => 'safha_one_page_sanitize_choices'
	));
	$wp_customize->add_control(
	    'safha_one_page_h1_font_family', array(
	    'section'  => 'safha_one_page_typography',
	    'label'    => __( 'H1 Fonts','safha-one-page'),
	    'type'     => 'select',
	    'choices'  => $safha_one_page_font_array,
	));

	//This is H1 FontSize setting
	$wp_customize->add_setting('safha_one_page_h1_font_size',array(
		'default'	=> '',
		'sanitize_callback'	=> 'sanitize_text_field'
	));
	$wp_customize->add_control('safha_one_page_h1_font_size',array(
		'label'	=> __('H1 Font Size','safha-one-page'),
		'section'	=> 'safha_one_page_typography',
		'setting'	=> 'safha_one_page_h1_font_size',
		'type'	=> 'text'
	));

	// This is H2 Color picker setting
	$wp_customize->add_setting( 'safha_one_page_h2_color', array(
		'default' => '',
		'sanitize_callback'	=> 'sanitize_hex_color'
	));
	$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'safha_one_page_h2_color', array(
		'label' => __('h2 Color', 'safha-one-page'),
		'section' => 'safha_one_page_typography',
		'settings' => 'safha_one_page_h2_color',
	)));

	//This is H2 FontFamily picker setting
	$wp_customize->add_setting('safha_one_page_h2_font_family',array(
	  'default' => '',
	  'capability' => 'edit_theme_options',
	  'sanitize_callback' => 'safha_one_page_sanitize_choices'
	));
	$wp_customize->add_control(
	    'safha_one_page_h2_font_family', array(
	    'section'  => 'safha_one_page_typography',
	    'label'    => __( 'h2 Fonts','safha-one-page'),
	    'type'     => 'select',
	    'choices'  => $safha_one_page_font_array,
	));

	//This is H2 FontSize setting
	$wp_customize->add_setting('safha_one_page_h2_font_size',array(
		'default'	=> '',
		'sanitize_callback'	=> 'sanitize_text_field'
	));
	$wp_customize->add_control('safha_one_page_h2_font_size',array(
		'label'	=> __('h2 Font Size','safha-one-page'),
		'section'	=> 'safha_one_page_typography',
		'setting'	=> 'safha_one_page_h2_font_size',
		'type'	=> 'text'
	));

	// This is H3 Color picker setting
	$wp_customize->add_setting( 'safha_one_page_h3_color', array(
		'default' => '',
		'sanitize_callback'	=> 'sanitize_hex_color'
	));
	$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'safha_one_page_h3_color', array(
		'label' => __('h3 Color', 'safha-one-page'),
		'section' => 'safha_one_page_typography',
		'settings' => 'safha_one_page_h3_color',
	)));

	//This is H3 FontFamily picker setting
	$wp_customize->add_setting('safha_one_page_h3_font_family',array(
	  'default' => '',
	  'capability' => 'edit_theme_options',
	  'sanitize_callback' => 'safha_one_page_sanitize_choices'
	));
	$wp_customize->add_control(
	    'safha_one_page_h3_font_family', array(
	    'section'  => 'safha_one_page_typography',
	    'label'    => __( 'h3 Fonts','safha-one-page'),
	    'type'     => 'select',
	    'choices'  => $safha_one_page_font_array,
	));

	//This is H3 FontSize setting
	$wp_customize->add_setting('safha_one_page_h3_font_size',array(
		'default'	=> '',
		'sanitize_callback'	=> 'sanitize_text_field'
	));
	$wp_customize->add_control('safha_one_page_h3_font_size',array(
		'label'	=> __('h3 Font Size','safha-one-page'),
		'section'	=> 'safha_one_page_typography',
		'setting'	=> 'safha_one_page_h3_font_size',
		'type'	=> 'text'
	));

	// This is H4 Color picker setting
	$wp_customize->add_setting( 'safha_one_page_h4_color', array(
		'default' => '',
		'sanitize_callback'	=> 'sanitize_hex_color'
	));
	$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'safha_one_page_h4_color', array(
		'label' => __('h4 Color', 'safha-one-page'),
		'section' => 'safha_one_page_typography',
		'settings' => 'safha_one_page_h4_color',
	)));

	//This is H4 FontFamily picker setting
	$wp_customize->add_setting('safha_one_page_h4_font_family',array(
	  'default' => '',
	  'capability' => 'edit_theme_options',
	  'sanitize_callback' => 'safha_one_page_sanitize_choices'
	));
	$wp_customize->add_control(
	    'safha_one_page_h4_font_family', array(
	    'section'  => 'safha_one_page_typography',
	    'label'    => __( 'h4 Fonts','safha-one-page'),
	    'type'     => 'select',
	    'choices'  => $safha_one_page_font_array,
	));

	//This is H4 FontSize setting
	$wp_customize->add_setting('safha_one_page_h4_font_size',array(
		'default'	=> '',
		'sanitize_callback'	=> 'sanitize_text_field'
	));
	$wp_customize->add_control('safha_one_page_h4_font_size',array(
		'label'	=> __('h4 Font Size','safha-one-page'),
		'section'	=> 'safha_one_page_typography',
		'setting'	=> 'safha_one_page_h4_font_size',
		'type'	=> 'text'
	));

	// This is H5 Color picker setting
	$wp_customize->add_setting( 'safha_one_page_h5_color', array(
		'default' => '',
		'sanitize_callback'	=> 'sanitize_hex_color'
	));
	$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'safha_one_page_h5_color', array(
		'label' => __('h5 Color', 'safha-one-page'),
		'section' => 'safha_one_page_typography',
		'settings' => 'safha_one_page_h5_color',
	)));

	//This is H5 FontFamily picker setting
	$wp_customize->add_setting('safha_one_page_h5_font_family',array(
	  'default' => '',
	  'capability' => 'edit_theme_options',
	  'sanitize_callback' => 'safha_one_page_sanitize_choices'
	));
	$wp_customize->add_control(
	    'safha_one_page_h5_font_family', array(
	    'section'  => 'safha_one_page_typography',
	    'label'    => __( 'h5 Fonts','safha-one-page'),
	    'type'     => 'select',
	    'choices'  => $safha_one_page_font_array,
	));

	//This is H5 FontSize setting
	$wp_customize->add_setting('safha_one_page_h5_font_size',array(
		'default'	=> '',
		'sanitize_callback'	=> 'sanitize_text_field'
	));
	$wp_customize->add_control('safha_one_page_h5_font_size',array(
		'label'	=> __('h5 Font Size','safha-one-page'),
		'section'	=> 'safha_one_page_typography',
		'setting'	=> 'safha_one_page_h5_font_size',
		'type'	=> 'text'
	));

	// This is H6 Color picker setting
	$wp_customize->add_setting( 'safha_one_page_h6_color', array(
		'default' => '',
		'sanitize_callback'	=> 'sanitize_hex_color'
	));
	$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'safha_one_page_h6_color', array(
		'label' => __('h6 Color', 'safha-one-page'),
		'section' => 'safha_one_page_typography',
		'settings' => 'safha_one_page_h6_color',
	)));

	//This is H6 FontFamily picker setting
	$wp_customize->add_setting('safha_one_page_h6_font_family',array(
	  'default' => '',
	  'capability' => 'edit_theme_options',
	  'sanitize_callback' => 'safha_one_page_sanitize_choices'
	));
	$wp_customize->add_control(
	    'safha_one_page_h6_font_family', array(
	    'section'  => 'safha_one_page_typography',
	    'label'    => __( 'h6 Fonts','safha-one-page'),
	    'type'     => 'select',
	    'choices'  => $safha_one_page_font_array,
	));

	//This is H6 FontSize setting
	$wp_customize->add_setting('safha_one_page_h6_font_size',array(
		'default'	=> '',
		'sanitize_callback'	=> 'sanitize_text_field'
	));
	$wp_customize->add_control('safha_one_page_h6_font_size',array(
		'label'	=> __('h6 Font Size','safha-one-page'),
		'section'	=> 'safha_one_page_typography',
		'setting'	=> 'safha_one_page_h6_font_size',
		'type'	=> 'text'
	));

	// background skin mode
	$wp_customize->add_setting('safha_one_page_background_image_type',array(
        'default' => 'Transparent',
        'sanitize_callback' => 'safha_one_page_sanitize_choices'
	));
	$wp_customize->add_control('safha_one_page_background_image_type',array(
        'type' => 'radio',
        'label' => __('Background Skin Mode','safha-one-page'),
        'section' => 'background_image',
        'choices' => array(
            'Transparent' => __('Transparent','safha-one-page'),
            'Background' => __('Background','safha-one-page'),
        ),
	) );

	// Add the Theme Color Option section.
	$wp_customize->add_section( 'safha_one_page_theme_color_option', array( 
		'panel' => 'safha_one_page_panel_id', 
		'title' => esc_html__( 'Theme Color Option', 'safha-one-page' ) )
	);

  	$wp_customize->add_setting( 'safha_one_page_theme_color_first', array(
	    'default' => '#00c7fe',
	    'sanitize_callback' => 'sanitize_hex_color'
  	));
  	$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'safha_one_page_theme_color_first', array(
  		'label' =>__( 'Color Option', 'safha-one-page' ),
	    'description' => __('One can change complete theme color on just one click.', 'safha-one-page'),
	    'section' => 'safha_one_page_theme_color_option',
	    'settings' => 'safha_one_page_theme_color_first',
  	)));

  	$wp_customize->add_setting( 'safha_one_page_theme_color_second', array(
	    'default' => '#01305c',
	    'sanitize_callback' => 'sanitize_hex_color'
  	));
  	$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'safha_one_page_theme_color_second', array(
  		'label' =>__( 'Color Option', 'safha-one-page' ),
	    'description' => __('One can change complete theme color on just one click.', 'safha-one-page'),
	    'section' => 'safha_one_page_theme_color_option',
	    'settings' => 'safha_one_page_theme_color_second',
  	)));

  	// woocommerce Options
	$wp_customize->add_section( 'safha_one_page_shop_page_options', array(
    	'title'      => __( 'Shop Page Settings', 'safha-one-page' ),
		'panel' => 'safha_one_page_panel_id'
	) );

	$wp_customize->add_setting('safha_one_page_display_related_products',array(
       'default' => true,
       'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
    ));
    $wp_customize->add_control('safha_one_page_display_related_products',array(
       'type' => 'checkbox',
       'label' => __('Related Product','safha-one-page'),
       'section' => 'safha_one_page_shop_page_options',
    ));

    $wp_customize->add_setting('safha_one_page_shop_products_border',array(
       'default' => true,
       'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
    ));
    $wp_customize->add_control('safha_one_page_shop_products_border',array(
       'type' => 'checkbox',
       'label' => __('Product Border','safha-one-page'),
       'section' => 'safha_one_page_shop_page_options',
    ));

    $wp_customize->add_setting('safha_one_page_shop_page_sidebar',array(
       'default' => true,
       'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
    ));
    $wp_customize->add_control('safha_one_page_shop_page_sidebar',array(
       'type' => 'checkbox',
       'label' => __('Enable / Disable Shop Page Sidebar','safha-one-page'),
       'section' => 'safha_one_page_shop_page_options',
    ));

    $wp_customize->add_setting('safha_one_page_single_product_sidebar',array(
        'default' => true,
        'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
	));
	$wp_customize->add_control('safha_one_page_single_product_sidebar',array(
     	'type' => 'checkbox',
      	'label' => __('Enable / Disable Single Product Sidebar','safha-one-page'),
      	'section' => 'safha_one_page_shop_page_options',
	));

	$wp_customize->add_setting( 'safha_one_page_woocommerce_product_per_columns' , array(
		'default'           => 3,
		'transport'         => 'refresh',
		'sanitize_callback' => 'safha_one_page_sanitize_choices',
	) );
	$wp_customize->add_control( new WP_Customize_Control( $wp_customize, 'safha_one_page_woocommerce_product_per_columns', array(
		'label'    => __( 'Total Products Per Columns', 'safha-one-page' ),
		'section'  => 'safha_one_page_shop_page_options',
		'type'     => 'radio',
		'choices'  => array(
						'2' => '2',
						'3' => '3',
						'4' => '4',
						'5' => '5',
		),
	) ) );

	$wp_customize->add_setting('safha_one_page_woocommerce_product_per_page',array(
		'default'	=> 9,
		'sanitize_callback'	=> 'safha_one_page_sanitize_float',
	));	
	$wp_customize->add_control('safha_one_page_woocommerce_product_per_page',array(
		'label'	=> __('Total Products Per Page','safha-one-page'),
		'section'	=> 'safha_one_page_shop_page_options',
		'type'		=> 'number'
	));

	$wp_customize->add_setting( 'safha_one_page_shop_page_top_padding',array(
		'default' => 10,
		'sanitize_callback'	=> 'safha_one_page_sanitize_float',
	));
	$wp_customize->add_control( 'safha_one_page_shop_page_top_padding',	array(
		'label' => esc_html__( 'Product Padding (Top Bottom)','safha-one-page' ),
		'section' => 'safha_one_page_shop_page_options',
		'input_attrs' => array(
			'min' => 0,
			'max' => 50,
			'step' => 1,
		),
		'type'		=> 'number'
	));

	$wp_customize->add_setting( 'safha_one_page_shop_page_left_padding',array(
		'default' => 10,
		'sanitize_callback'	=> 'safha_one_page_sanitize_float',
	));
	$wp_customize->add_control( 'safha_one_page_shop_page_left_padding',	array(
		'label' => esc_html__( 'Product Padding (Right Left)','safha-one-page' ),
		'section' => 'safha_one_page_shop_page_options',
		'input_attrs' => array(
			'min' => 0,
			'max' => 50,
			'step' => 1,
		),
		'type'		=> 'number'
	));

	$wp_customize->add_setting( 'safha_one_page_shop_page_border_radius',array(
		'default' => 0,
		'sanitize_callback'	=> 'safha_one_page_sanitize_float',
	));
	$wp_customize->add_control('safha_one_page_shop_page_border_radius',array(
		'label' => esc_html__( 'Product Border Radius','safha-one-page' ),
		'section' => 'safha_one_page_shop_page_options',
		'input_attrs' => array(
			'min' => 0,
			'max' => 50,
			'step' => 1,
		),
		'type'		=> 'number'
	));

	$wp_customize->add_setting( 'safha_one_page_shop_page_box_shadow',array(
		'default' => 0,
		'sanitize_callback'	=> 'safha_one_page_sanitize_float',
	));
	$wp_customize->add_control('safha_one_page_shop_page_box_shadow',array(
		'label' => esc_html__( 'Product Shadow','safha-one-page' ),
		'section' => 'safha_one_page_shop_page_options',
		'input_attrs' => array(
			'min' => 0,
			'max' => 50,
			'step' => 1,
		),
		'type'		=> 'number'
	));

	$wp_customize->add_setting( 'safha_one_page_shop_button_padding_top',array(
		'default' => 9,
		'sanitize_callback'	=> 'safha_one_page_sanitize_float',
	));
	$wp_customize->add_control('safha_one_page_shop_button_padding_top',	array(
		'label' => esc_html__( 'Button Padding (Top Bottom)','safha-one-page' ),
		'section' => 'safha_one_page_shop_page_options',
		'input_attrs' => array(
			'min' => 0,
			'max' => 50,
			'step' => 1,
		),
		'type'		=> 'number',

	));

	$wp_customize->add_setting( 'safha_one_page_shop_button_padding_left',array(
		'default' => 16,
		'sanitize_callback'	=> 'safha_one_page_sanitize_float',
	));
	$wp_customize->add_control('safha_one_page_shop_button_padding_left',array(
		'label' => esc_html__( 'Button Padding (Right Left)','safha-one-page' ),
		'section' => 'safha_one_page_shop_page_options',
		'type'		=> 'number',
		'input_attrs' => array(
			'min' => 0,
			'max' => 50,
			'step' => 1,
		),
	));

	$wp_customize->add_setting( 'safha_one_page_shop_button_border_radius',array(
		'default' => 25,
		'sanitize_callback'	=> 'safha_one_page_sanitize_float',
	));
	$wp_customize->add_control('safha_one_page_shop_button_border_radius',array(
		'label' => esc_html__( 'Button Border Radius','safha-one-page' ),
		'section' => 'safha_one_page_shop_page_options',
		'type'		=> 'number',
		'input_attrs' => array(
			'min' => 0,
			'max' => 50,
			'step' => 1,
		),
	));

	$wp_customize->add_setting('safha_one_page_position_product_sale',array(
        'default' => 'Right',
        'sanitize_callback' => 'safha_one_page_sanitize_choices'
	));
	$wp_customize->add_control('safha_one_page_position_product_sale',array(
        'type' => 'radio',
        'label' => __('Product Sale Position','safha-one-page'),
        'section' => 'safha_one_page_shop_page_options',
        'choices' => array(
            'Right' => __('Right','safha-one-page'),
            'Left' => __('Left','safha-one-page'),
        ),
	) );

	$wp_customize->add_setting( 'safha_one_page_border_radius_product_sale_text',array(
		'default' => 50,
		'sanitize_callback'	=> 'safha_one_page_sanitize_float',
	));
	$wp_customize->add_control('safha_one_page_border_radius_product_sale_text', array(
        'label'  => __('Product Sale Border Radius','safha-one-page'),
        'section'  => 'safha_one_page_shop_page_options',
        'type'        => 'number',
        'input_attrs' => array(
        	'step'=> 1,
            'min' => 0,
            'max' => 50,
        )
    ) );

    $wp_customize->add_setting('safha_one_page_top_bottom_product_sale_padding',array(
		'default'=> '',
		'sanitize_callback'	=> 'safha_one_page_sanitize_float',
	));
	$wp_customize->add_control('safha_one_page_top_bottom_product_sale_padding',array(
		'label'	=> __('Top / Bottom Product Sale Padding ','safha-one-page'),
		'input_attrs' => array(
            'step'             => 1,
			'min'              => 0,
			'max'              => 50,
        ),
		'section'=> 'safha_one_page_shop_page_options',
		'type'=> 'number'
	));

	$wp_customize->add_setting('safha_one_page_left_right_product_sale_padding',array(
		'default'=> '',
		'sanitize_callback'	=> 'safha_one_page_sanitize_float',
	));
	$wp_customize->add_control('safha_one_page_left_right_product_sale_padding',array(
		'label'	=> __('Left / Right Product Sale Padding','safha-one-page'),
		'input_attrs' => array(
            'step'             => 1,
			'min'              => 0,
			'max'              => 50,
        ),
		'section'=> 'safha_one_page_shop_page_options',
		'type'=> 'number'
	));

	$wp_customize->add_setting('safha_one_page_product_sale_text_size',array(
		'default'=> 14,
		'sanitize_callback'	=> 'safha_one_page_sanitize_float'
	));
	$wp_customize->add_control('safha_one_page_product_sale_text_size',array(
		'label'	=> __('Product Sale Text Size','safha-one-page'),
		'input_attrs' => array(
            'step'             => 1,
			'min'              => 0,
			'max'              => 50,
        ),
		'section'=> 'safha_one_page_shop_page_options',
		'type'=> 'number'
	));

	$wp_customize->add_setting( 'safha_one_page_top_bottom_product_sale_padding',array(
		'default' => 0,
		'sanitize_callback'	=> 'safha_one_page_sanitize_float',
	));
	$wp_customize->add_control('safha_one_page_top_bottom_product_sale_padding',	array(
		'label' => esc_html__( 'Top / Bottom Product Sale Padding','safha-one-page' ),
		'section' => 'safha_one_page_shop_page_options',
		'input_attrs' => array(
			'min' => 0,
			'max' => 50,
			'step' => 1,
		),
		'type'		=> 'number',

	));

	$wp_customize->add_setting( 'safha_one_page_left_right_product_sale_padding',array(
		'default' => 0,
		'sanitize_callback'	=> 'safha_one_page_sanitize_float',
	));
	$wp_customize->add_control('safha_one_page_left_right_product_sale_padding',array(
		'label' => esc_html__( 'Left / Right Product Sale Padding','safha-one-page' ),
		'section' => 'safha_one_page_shop_page_options',
		'type'		=> 'number',
		'input_attrs' => array(
			'min' => 0,
			'max' => 50,
			'step' => 1,
		),
	));

	$wp_customize->add_setting('safha_one_page_shop_products_navigation',array(
       'default' => 'Yes',
       'sanitize_callback'	=> 'safha_one_page_sanitize_choices'
    ));
    $wp_customize->add_control('safha_one_page_shop_products_navigation',array(
       'type' => 'radio',
       'label' => __('Woocommerce Products Navigation','safha-one-page'),
       'choices' => array(
            'Yes' => __('Yes','safha-one-page'),
            'No' => __('No','safha-one-page'),
        ),
       'section' => 'safha_one_page_shop_page_options',
    ));

  	//Layout Settings
	$wp_customize->add_section( 'safha_one_page_width_layout', array(
    	'title'      => __( 'Layout Settings', 'safha-one-page' ),
		'panel' => 'safha_one_page_panel_id'
	) );
	
	// show/hide search
	$wp_customize->add_setting( 'safha_one_page_show_hide_search',array(
		'default' => true,
      	'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
    ) );
    $wp_customize->add_control('safha_one_page_show_hide_search',array(
    	'type' => 'checkbox',
        'label' => __( 'Show / Hide Search','safha-one-page' ),
        'section' => 'safha_one_page_width_layout'
    ));

    $wp_customize->add_setting('safha_one_page_search_icon_changer',array(
		'default'	=> 'fas fa-search',
		'sanitize_callback'	=> 'sanitize_text_field'
	));	
	$wp_customize->add_control(new safha_one_page_Icon_Changer(
        $wp_customize,'safha_one_page_search_icon_changer',array(
		'label'	=> __('Search Icon','safha-one-page'),
		'transport' => 'refresh',
		'section'	=> 'safha_one_page_width_layout',
		'type'		=> 'icon'
	)));

	$wp_customize->add_setting( 'safha_one_page_fixed_header',array(
		'default' => false,
      	'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
    ) );
    $wp_customize->add_control('safha_one_page_fixed_header',array(
    	'type' => 'checkbox',
        'label' => __( 'Enable / Disable Fixed Header','safha-one-page' ),
        'section' => 'safha_one_page_width_layout'
    ));

    $wp_customize->add_setting( 'safha_one_page_fixed_header_padding_option', array(
		'default'=> '',
		'sanitize_callback'	=> 'safha_one_page_sanitize_float',
	) );
	$wp_customize->add_control( 'safha_one_page_fixed_header_padding_option', array(
		'label'       => esc_html__( 'Fixed Header Padding','safha-one-page' ),
		'section'     => 'safha_one_page_width_layout',
		'type'        => 'number',
		'input_attrs' => array(
			'step'             => 1,
			'min'              => 0,
			'max'              => 50,
		),
	) );

	$wp_customize->add_setting('safha_one_page_loader_setting',array(
       'default' => false,
       'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
    ));
    $wp_customize->add_control('safha_one_page_loader_setting',array(
       'type' => 'checkbox',
       'label' => __('Enable / Disable Preloader','safha-one-page'),
       'section' => 'safha_one_page_width_layout'
    ));

    $wp_customize->add_setting('safha_one_page_preloader_types',array(
        'default' => 'Default',
        'sanitize_callback' => 'safha_one_page_sanitize_choices'
	));
	$wp_customize->add_control('safha_one_page_preloader_types',array(
        'type' => 'radio',
        'label' => __('Preloader Option','safha-one-page'),
        'section' => 'safha_one_page_width_layout',
        'choices' => array(
            'Default' => __('Default','safha-one-page'),
            'Circle' => __('Circle','safha-one-page'),
            'Two Circle' => __('Two Circle','safha-one-page')
        ),
	) );

    $wp_customize->add_setting( 'safha_one_page_loader_color_setting', array(
	    'default' => '#fff',
	    'sanitize_callback' => 'sanitize_hex_color'
  	));
  	$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'safha_one_page_loader_color_setting', array(
  		'label' => __('Preloader Color Option', 'safha-one-page'),
	    'section' => 'safha_one_page_width_layout',
	    'settings' => 'safha_one_page_loader_color_setting',
  	)));

  	$wp_customize->add_setting( 'safha_one_page_loader_background_color', array(
	    'default' => '#000',
	    'sanitize_callback' => 'sanitize_hex_color'
  	));
  	$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'safha_one_page_loader_background_color', array(
  		'label' => __('Preloader Background Color Option', 'safha-one-page'),
	    'section' => 'safha_one_page_width_layout',
	    'settings' => 'safha_one_page_loader_background_color',
  	)));

	$wp_customize->add_setting('safha_one_page_theme_options',array(
    'default' => 'Default',
        'sanitize_callback' => 'safha_one_page_sanitize_choices'
	));
	$wp_customize->add_control('safha_one_page_theme_options',array(
        'type' => 'select',
        'label' => __('Container Box','safha-one-page'),
        'description' => __('Here you can change the Width layout. ','safha-one-page'),
        'section' => 'safha_one_page_width_layout',
        'choices' => array(
            'Default' => __('Default','safha-one-page'),
            'Wide Layout' => __('Wide Layout','safha-one-page'),
            'Box Layout' => __('Box Layout','safha-one-page'),
        ),
	) );

	$wp_customize->add_setting( 'safha_one_page_post_image_border_radius', array(
		'default'=> 0,
		'sanitize_callback'	=> 'safha_one_page_sanitize_float',
	) );
	$wp_customize->add_control( 'safha_one_page_post_image_border_radius', array(
		'label'       => esc_html__( 'Featured Image Border Radius','safha-one-page' ),
		'section'     => 'safha_one_page_width_layout',
		'type'        => 'number',
		'input_attrs' => array(
			'step'             => 1,
			'min'              => 0,
			'max'              => 100,
		),
	) );

	$wp_customize->add_setting( 'safha_one_page_featured_image_box_shadow',array(
		'default' => 0,
		'sanitize_callback'    => 'safha_one_page_sanitize_number_range',
	));
	$wp_customize->add_control('safha_one_page_featured_image_box_shadow',array(
		'label' => esc_html__( 'Featured Image Shadow','safha-one-page' ),
		'section' => 'safha_one_page_width_layout',
		'input_attrs' => array(
			'min' => 0,
			'max' => 50,
			'step' => 1,
		),
		'type' => 'range'
	));

	// Button Settings
	$wp_customize->add_section( 'safha_one_page_button_option', array(
		'title' => __('Button','safha-one-page'),
		'panel' => 'safha_one_page_panel_id',
	));

	$wp_customize->add_setting('safha_one_page_top_bottom_padding',array(
		'default'=> '',
		'sanitize_callback'	=> 'safha_one_page_sanitize_float',
	));
	$wp_customize->add_control('safha_one_page_top_bottom_padding',array(
		'label'	=> __('Top and Bottom Padding ','safha-one-page'),
		'input_attrs' => array(
            'step'             => 1,
			'min'              => 0,
			'max'              => 50,
        ),
		'section'=> 'safha_one_page_button_option',
		'type'=> 'number'
	));

	$wp_customize->add_setting('safha_one_page_left_right_padding',array(
		'default'=> '',
		'sanitize_callback'	=> 'safha_one_page_sanitize_float',
	));
	$wp_customize->add_control('safha_one_page_left_right_padding',array(
		'label'	=> __('Left and Right Padding','safha-one-page'),
		'input_attrs' => array(
            'step'             => 1,
			'min'              => 0,
			'max'              => 50,
        ),
		'section'=> 'safha_one_page_button_option',
		'type'=> 'number'
	));

	$wp_customize->add_setting( 'safha_one_page_border_radius', array(
		'default'=> '',
		'sanitize_callback'	=> 'safha_one_page_sanitize_float',
	) );
	$wp_customize->add_control( 'safha_one_page_border_radius', array(
		'label'       => esc_html__( 'Button Border Radius','safha-one-page' ),
		'section'     => 'safha_one_page_button_option',
		'type'        => 'number',
		'input_attrs' => array(
			'step'             => 1,
			'min'              => 0,
			'max'              => 50,
		),
	) );

	$wp_customize->add_section( 'safha_one_page_general_option', array(
    	'title'      => __( 'Sidebar Settings', 'safha-one-page' ),
		'panel' => 'safha_one_page_panel_id'
	) );

	// Add Settings and Controls for Layout
	$wp_customize->add_setting('safha_one_page_layout_settings',array(
        'default' => 'Right Sidebar',
        'sanitize_callback' => 'safha_one_page_sanitize_choices'
	));
	$wp_customize->add_control('safha_one_page_layout_settings',array(
        'type' => 'radio',
        'label' => __('Post Sidebar Layout','safha-one-page'),
        'section' => 'safha_one_page_general_option',
        'description' => __('This option work for blog page, blog single page, archive page and search page.','safha-one-page'),
        'choices' => array(
            'Left Sidebar' => __('Left Sidebar','safha-one-page'),
            'Right Sidebar' => __('Right Sidebar','safha-one-page'),
            'One Column' => __('Full Column','safha-one-page'),
            'Grid Layout' => __('Grid Layout','safha-one-page')
        ),
	) );

	$wp_customize->add_setting('safha_one_page_page_sidebar_option',array(
        'default' => 'One Column',
        'sanitize_callback' => 'safha_one_page_sanitize_choices'
	));
	$wp_customize->add_control('safha_one_page_page_sidebar_option',array(
        'type' => 'radio',
        'label' => __('Page Sidebar Layout','safha-one-page'),
        'section' => 'safha_one_page_general_option',
        'choices' => array(
            'Left Sidebar' => __('Left Sidebar','safha-one-page'),
            'Right Sidebar' => __('Right Sidebar','safha-one-page'),
            'One Column' => __('Full Column','safha-one-page')
        ),
	) );

	//Topbar section
	$wp_customize->add_section('safha_one_page_contact_details',array(
		'title'	=> __('Topbar Section','safha-one-page'),
		'description'	=> __('Add Header Content here','safha-one-page'),
		'priority'	=> null,
		'panel' => 'safha_one_page_panel_id',
	));

	//Show /Hide Topbar
	$wp_customize->add_setting( 'safha_one_page_show_hide_topbar',array(
		'default' => false,
      	'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
    ) );
    $wp_customize->add_control('safha_one_page_show_hide_topbar',array(
    	'type' => 'checkbox',
        'label' => __( 'Show / Hide Top Header','safha-one-page' ),
        'section' => 'safha_one_page_contact_details'
    ));

	$wp_customize->add_setting('safha_one_page_email_address',array(
		'default'	=> '',
		'sanitize_callback'	=> 'sanitize_email'
	));	
	$wp_customize->add_control('safha_one_page_email_address',array(
		'label'	=> __('Add Email','safha-one-page'),
		'section'	=> 'safha_one_page_contact_details',
		'setting'	=> 'safha_one_page_email_address',
		'type'		=> 'text'
	));

	$wp_customize->add_setting('safha_one_page_email_icon_changer',array(
		'default'	=> 'fa fa-envelope',
		'sanitize_callback'	=> 'sanitize_text_field'
	));	
	$wp_customize->add_control(new safha_one_page_Icon_Changer(
        $wp_customize,'safha_one_page_email_icon_changer',array(
		'label'	=> __('Email Icon','safha-one-page'),
		'transport' => 'refresh',
		'section'	=> 'safha_one_page_contact_details',
		'type'		=> 'icon'
	)));

	$wp_customize->add_setting('safha_one_page_time',array(
		'default'	=> '',
		'sanitize_callback'	=> 'sanitize_text_field'
	));
	$wp_customize->add_control('safha_one_page_time',array(
		'label'	=> __('Add Time','safha-one-page'),
		'section'	=> 'safha_one_page_contact_details',
		'setting'	=> 'safha_one_page_time',
		'type'		=> 'text'
	));

	$wp_customize->add_setting('safha_one_page_time_icon_changer',array(
		'default'	=> 'far fa-clock',
		'sanitize_callback'	=> 'sanitize_text_field'
	));	
	$wp_customize->add_control(new safha_one_page_Icon_Changer(
        $wp_customize,'safha_one_page_time_icon_changer',array(
		'label'	=> __('Time Icon','safha-one-page'),
		'transport' => 'refresh',
		'section'	=> 'safha_one_page_contact_details',
		'type'		=> 'icon'
	)));

	$wp_customize->add_setting('safha_one_page_contact_number',array(
		'default'	=> '',
		'sanitize_callback'	=> 'safha_one_page_sanitize_phone_number'
	));
	$wp_customize->add_control('safha_one_page_contact_number',array(
		'label'	=> __('Add Phone Number','safha-one-page'),
		'section'	=> 'safha_one_page_contact_details',
		'setting'	=> 'safha_one_page_contact_number',
		'type'		=> 'text'
	));

	$wp_customize->add_setting('safha_one_page_phone_icon_changer',array(
		'default'	=> 'fa fa-phone',
		'sanitize_callback'	=> 'sanitize_text_field'
	));	
	$wp_customize->add_control(new safha_one_page_Icon_Changer(
        $wp_customize,'safha_one_page_phone_icon_changer',array(
		'label'	=> __('Phone Icon','safha-one-page'),
		'transport' => 'refresh',
		'section'	=> 'safha_one_page_contact_details',
		'type'		=> 'icon'
	)));

	$wp_customize->add_setting('safha_one_page_facebook_url',array(
		'default'	=> '',
		'sanitize_callback'	=> 'esc_url_raw'
	));	
	$wp_customize->add_control('safha_one_page_facebook_url',array(
		'label'	=> __('Add Facebook link','safha-one-page'),
		'section'	=> 'safha_one_page_contact_details',
		'setting'	=> 'safha_one_page_facebook_url',
		'type'	=> 'url'
	));

	$wp_customize->add_setting('safha_one_page_facebook_icon_changer',array(
		'default'	=> 'fab fa-facebook-f',
		'sanitize_callback'	=> 'sanitize_text_field'
	));	
	$wp_customize->add_control(new safha_one_page_Icon_Changer(
        $wp_customize,'safha_one_page_facebook_icon_changer',array(
		'label'	=> __('Facebook Icon','safha-one-page'),
		'transport' => 'refresh',
		'section'	=> 'safha_one_page_contact_details',
		'type'		=> 'icon'
	)));

	$wp_customize->add_setting('safha_one_page_twitter_url',array(
		'default'	=> '',
		'sanitize_callback'	=> 'esc_url_raw'
	));	
	$wp_customize->add_control('safha_one_page_twitter_url',array(
		'label'	=> __('Add Twitter link','safha-one-page'),
		'section'	=> 'safha_one_page_contact_details',
		'setting'	=> 'safha_one_page_twitter_url',
		'type'	=> 'url'
	));

	$wp_customize->add_setting('safha_one_page_twitter_icon_changer',array(
		'default'	=> 'fab fa-twitter',
		'sanitize_callback'	=> 'sanitize_text_field'
	));	
	$wp_customize->add_control(new safha_one_page_Icon_Changer(
        $wp_customize,'safha_one_page_twitter_icon_changer',array(
		'label'	=> __('Twitter Icon','safha-one-page'),
		'transport' => 'refresh',
		'section'	=> 'safha_one_page_contact_details',
		'type'		=> 'icon'
	)));

	$wp_customize->add_setting('safha_one_page_youtube_url',array(
		'default'	=> '',
		'sanitize_callback'	=> 'esc_url_raw'
	));	
	$wp_customize->add_control('safha_one_page_youtube_url',array(
		'label'	=> __('Add Youtube link','safha-one-page'),
		'section'	=> 'safha_one_page_contact_details',
		'setting'	=> 'safha_one_page_youtube_url',
		'type'	=> 'url'
	));

	$wp_customize->add_setting('safha_one_page_youtube_icon_changer',array(
		'default'	=> 'fab fa-youtube',
		'sanitize_callback'	=> 'sanitize_text_field'
	));	
	$wp_customize->add_control(new safha_one_page_Icon_Changer(
        $wp_customize,'safha_one_page_youtube_icon_changer',array(
		'label'	=> __('Youtube Icon','safha-one-page'),
		'transport' => 'refresh',
		'section'	=> 'safha_one_page_contact_details',
		'type'		=> 'icon'
	)));

	$wp_customize->add_setting('safha_one_page_linkedin_url',array(
		'default'	=> '',
		'sanitize_callback'	=> 'esc_url_raw'
	));
	$wp_customize->add_control('safha_one_page_linkedin_url',array(
		'label'	=> __('Add Linkedin link','safha-one-page'),
		'section'	=> 'safha_one_page_contact_details',
		'setting'	=> 'safha_one_page_linkedin_url',
		'type'	=> 'url'
	));

	$wp_customize->add_setting('safha_one_page_linkedin_icon_changer',array(
		'default'	=> 'fab fa-linkedin-in',
		'sanitize_callback'	=> 'sanitize_text_field'
	));	
	$wp_customize->add_control(new safha_one_page_Icon_Changer(
        $wp_customize,'safha_one_page_linkedin_icon_changer',array(
		'label'	=> __('Linkedin Icon','safha-one-page'),
		'transport' => 'refresh',
		'section'	=> 'safha_one_page_contact_details',
		'type'		=> 'icon'
	)));

	$wp_customize->add_setting('safha_one_page_instagram_url',array(
		'default'	=> '',
		'sanitize_callback'	=> 'esc_url_raw'
	));
	$wp_customize->add_control('safha_one_page_instagram_url',array(
		'label'	=> __('Add Instagram link','safha-one-page'),
		'section'	=> 'safha_one_page_contact_details',
		'setting'	=> 'safha_one_page_instagram_url',
		'type'	=> 'url'
	));

	$wp_customize->add_setting('safha_one_page_instagram_icon_changer',array(
		'default'	=> 'fab fa-instagram',
		'sanitize_callback'	=> 'sanitize_text_field'
	));	
	$wp_customize->add_control(new safha_one_page_Icon_Changer(
        $wp_customize,'safha_one_page_instagram_icon_changer',array(
		'label'	=> __('Instagram Icon','safha-one-page'),
		'transport' => 'refresh',
		'section'	=> 'safha_one_page_contact_details',
		'type'		=> 'icon'
	)));

	// navigation menu 
	$wp_customize->add_section( 'safha_one_page_navigation_menu' , array(
    	'title'      => __( 'Navigation Menus Settings', 'safha-one-page' ),
		'priority'   => null,
		'panel' => 'safha_one_page_panel_id'
	) );

	$wp_customize->add_setting('safha_one_page_navigation_menu_font_size',array(
		'default'=> '',
		'sanitize_callback'	=> 'safha_one_page_sanitize_float',
	));
	$wp_customize->add_control('safha_one_page_navigation_menu_font_size',array(
		'label'	=> __('Navigation Menus Font Size ','safha-one-page'),
		'section'=> 'safha_one_page_navigation_menu',
		'input_attrs' => array(
            'step'             => 1,
			'min'              => 0,
			'max'              => 50,
        ),
		'type'=> 'number'
	));

	$wp_customize->add_setting('safha_one_page_menu_text_tranform',array(
        'default' => 'Default',
        'sanitize_callback' => 'safha_one_page_sanitize_choices'
    ));
    $wp_customize->add_control('safha_one_page_menu_text_tranform',array(
        'type' => 'radio',
        'label' => __('Navigation Menus Text Transform','safha-one-page'),
        'section' => 'safha_one_page_navigation_menu',
        'choices' => array(
            'Default' => __('Default','safha-one-page'),
            'Capitalize' => __('Capitalize','safha-one-page'),
        ),
	) );

	$wp_customize->add_setting('safha_one_page_menu_font_weight',array(
        'default' => 'Default',
        'sanitize_callback' => 'safha_one_page_sanitize_choices'
    ));
    $wp_customize->add_control('safha_one_page_menu_font_weight',array(
        'type' => 'radio',
        'label' => __('Navigation Menus Font Weight','safha-one-page'),
        'section' => 'safha_one_page_navigation_menu',
        'choices' => array(
            'Default' => __('Default','safha-one-page'),
            'Normal' => __('Normal','safha-one-page'),
        ),
	) );

	//home page slider
	$wp_customize->add_section( 'safha_one_page_slider' , array(
    	'title'      => __( 'Slider Settings', 'safha-one-page' ),
		'priority'   => null,
		'panel' => 'safha_one_page_panel_id'
	) );

	$wp_customize->add_setting('safha_one_page_slider_arrows',array(
        'default' => false,
        'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
	));
	$wp_customize->add_control('safha_one_page_slider_arrows',array(
     	'type' => 'checkbox',
      	'label' => __('Show / Hide slider','safha-one-page'),
      	'section' => 'safha_one_page_slider',
	));

	$wp_customize->add_setting('safha_one_page_slider_title',array(
       'default' => true,
       'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
    ));
    $wp_customize->add_control('safha_one_page_slider_title',array(
       'type' => 'checkbox',
       'label' => __('Show / Hide Slider Title','safha-one-page'),
       'section' => 'safha_one_page_slider'
    ));

    $wp_customize->add_setting('safha_one_page_slider_content',array(
       'default' => true,
       'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
    ));
    $wp_customize->add_control('safha_one_page_slider_content',array(
       'type' => 'checkbox',
       'label' => __('Show / Hide Slider Content','safha-one-page'),
       'section' => 'safha_one_page_slider'
    ));

    $wp_customize->add_setting('safha_one_page_slider_button',array(
       'default' => true,
       'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
    ));
    $wp_customize->add_control('safha_one_page_slider_button',array(
       'type' => 'checkbox',
       'label' => __('Show / Hide Slider Button','safha-one-page'),
       'section' => 'safha_one_page_slider'
    ));

    $wp_customize->add_setting('safha_one_page_slider_width_options',array(
    	'default' => 'Full Width',
     	'sanitize_callback' => 'safha_one_page_sanitize_choices'
	));
	$wp_customize->add_control('safha_one_page_slider_width_options',array(
		'type' => 'select',
		'label' => __('Slider Width Layout','safha-one-page'),
		'description' => __('Here you can change the Slider Width. ','safha-one-page'),
		'section' => 'safha_one_page_slider',
		'choices' => array(
		   'Full Width' => __('Full Width','safha-one-page'),
		   'Container Width' => __('Container Width','safha-one-page'),
		),
	) );

	for ( $count = 1; $count <= 4; $count++ ) {

		$wp_customize->add_setting( 'safha_one_page_slide_page' . $count, array(
			'default'           => '',
			'sanitize_callback' => 'safha_one_page_sanitize_dropdown_pages'
		) );
		$wp_customize->add_control( 'safha_one_page_slide_page' . $count, array(
			'label'    => __( 'Select Slide Image Page', 'safha-one-page' ),
			'section'  => 'safha_one_page_slider',
			'type'     => 'dropdown-pages'
		) );
	}

	$wp_customize->add_setting( 'safha_one_page_slider_speed',array(
		'default' => 3000,
		'sanitize_callback' => 'safha_one_page_sanitize_number_range',
	));
	$wp_customize->add_control( 'safha_one_page_slider_speed',array(
		'label' => esc_html__( 'Slider Speed','safha-one-page' ),
		'section' => 'safha_one_page_slider',
		'type'        => 'range',
		'input_attrs' => array(
			'min' => 1000,
			'max' => 5000,
			'step' => 500,
		),
	));

	$wp_customize->add_setting('safha_one_page_slider_height_option',array(
		'default'=> 600,
		'sanitize_callback'	=> 'sanitize_text_field'
	));
	$wp_customize->add_control('safha_one_page_slider_height_option',array(
		'label'	=> __('Slider Height Option','safha-one-page'),
		'section'=> 'safha_one_page_slider',
		'type'=> 'number'
	));

    $wp_customize->add_setting('safha_one_page_slider_content_option',array(
    'default' => 'Left',
        'sanitize_callback' => 'safha_one_page_sanitize_choices'
	));
	$wp_customize->add_control('safha_one_page_slider_content_option',array(
        'type' => 'select',
        'label' => __('Slider Content Layout','safha-one-page'),
        'section' => 'safha_one_page_slider',
        'choices' => array(
            'Center' => __('Center','safha-one-page'),
            'Left' => __('Left','safha-one-page'),
            'Right' => __('Right','safha-one-page'),
        ),
	) );

	$wp_customize->add_setting('safha_one_page_slider_button_text',array(
		'default'=> __('Read More','safha-one-page'),
		'sanitize_callback'	=> 'sanitize_text_field'
	));
	$wp_customize->add_control('safha_one_page_slider_button_text',array(
		'label'	=> __('Slider Button Text','safha-one-page'),
		'section'=> 'safha_one_page_slider',
		'type'=> 'text'
	));

	$wp_customize->add_setting( 'safha_one_page_slider_excerpt_number', array(
		'default'              => 20,
		'sanitize_callback' => 'safha_one_page_sanitize_number_range',
	) );
	$wp_customize->add_control( 'safha_one_page_slider_excerpt_number', array(
		'label'       => esc_html__( 'Slider Excerpt length','safha-one-page' ),
		'section'     => 'safha_one_page_slider',
		'type'        => 'range',
		'settings'    => 'safha_one_page_slider_excerpt_number',
		'input_attrs' => array(
			'step'             => 2,
			'min'              => 0,
			'max'              => 50,
		),
	) );

	$wp_customize->add_setting('safha_one_page_slider_opacity_color',array(
      'default'              =>  0.3,
      'sanitize_callback' => 'safha_one_page_sanitize_choices'
	));
	$wp_customize->add_control( 'safha_one_page_slider_opacity_color', array(
	'label'       => esc_html__( 'Slider Image Opacity','safha-one-page' ),
	'section'     => 'safha_one_page_slider',
	'type'        => 'select',
	'settings'    => 'safha_one_page_slider_opacity_color',
	'choices' => array(
      '0' =>  esc_attr('0','safha-one-page'),
      '0.1' =>  esc_attr('0.1','safha-one-page'),
      '0.2' =>  esc_attr('0.2','safha-one-page'),
      '0.3' =>  esc_attr('0.3','safha-one-page'),
      '0.4' =>  esc_attr('0.4','safha-one-page'),
      '0.5' =>  esc_attr('0.5','safha-one-page'),
      '0.6' =>  esc_attr('0.6','safha-one-page'),
      '0.7' =>  esc_attr('0.7','safha-one-page'),
      '0.8' =>  esc_attr('0.8','safha-one-page'),
      '0.9' =>  esc_attr('0.9','safha-one-page')
	),
	));

	$wp_customize->add_setting('safha_one_page_padding_top_bottom_slider_content',array(
		'default'=> '',
		'sanitize_callback'	=> 'safha_one_page_sanitize_float',
	));
	$wp_customize->add_control('safha_one_page_padding_top_bottom_slider_content',array(
		'label'	=> __('Top Bottom Slider Content Padding','safha-one-page'),
		'section'=> 'safha_one_page_slider',
		'input_attrs' => array(
            'step'             => 1,
			'min'              => 0,
			'max'              => 50,
        ),
		'type'=> 'number'
	));

	$wp_customize->add_setting('safha_one_page_padding_left_right_slider_content',array(
		'default'=> '',
		'sanitize_callback'	=> 'safha_one_page_sanitize_float',
	));
	$wp_customize->add_control('safha_one_page_padding_left_right_slider_content',array(
		'label'	=> __('Left Right Slider Content Padding','safha-one-page'),
		'section'=> 'safha_one_page_slider',
		'input_attrs' => array(
            'step'             => 1,
			'min'              => 0,
			'max'              => 50,
        ),
		'type'=> 'number'
	));

	$wp_customize->add_setting('safha_one_page_show_slider_image_overlay',array(
       'default' => true,
       'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
    ));
    $wp_customize->add_control('safha_one_page_show_slider_image_overlay',array(
       'type' => 'checkbox',
       'label' => __('Show / Hide Image Overlay Slider','safha-one-page'),
       'section' => 'safha_one_page_slider'
    ));

    $wp_customize->add_setting('safha_one_page_color_slider_image_overlay', array(
		'default'           => '',
		'sanitize_callback' => 'sanitize_hex_color',
	));
	$wp_customize->add_control(new WP_Customize_Color_Control($wp_customize, 'safha_one_page_color_slider_image_overlay', array(
		'label'    => __('Image Overlay Slider Color', 'safha-one-page'),
		'section'  => 'safha_one_page_slider',
		'settings' => 'safha_one_page_color_slider_image_overlay',
	)));
	
	//Our Features
	$wp_customize->add_section('safha_one_page_features',array(
		'title'	=> __('Our Features Section','safha-one-page'),
		'description'	=> __('Add Our Features sections below.','safha-one-page'),
		'panel' => 'safha_one_page_panel_id',
	));

	$wp_customize->add_setting('safha_one_page_features_title',array(
		'default'	=> '',
		'sanitize_callback'	=> 'sanitize_text_field'
	));	
	$wp_customize->add_control('safha_one_page_features_title',array(
		'label'	=> __('Section Title','safha-one-page'),
		'section'	=> 'safha_one_page_features',
		'type'		=> 'text'
	));

	$wp_customize->add_setting('safha_one_page_text',array(
		'default'	=> '',
		'sanitize_callback'	=> 'sanitize_text_field'
	));	
	$wp_customize->add_control('safha_one_page_text',array(
		'label'	=> __('Add Text','safha-one-page'),
		'section'	=> 'safha_one_page_features',
		'type'		=> 'text'
	));

	$categories = get_categories();
		$cat_posts = array();
			$i = 0;
			$cat_posts[]='Select';	
		foreach($categories as $category){
			if($i==0){
			$default = $category->slug;
			$i++;
		}
		$cat_posts[$category->slug] = $category->name;
	}

	$wp_customize->add_setting('safha_one_page_features_category',array(
		'default'	=> 'select',
		'sanitize_callback' => 'safha_one_page_sanitize_choices',
	));
	$wp_customize->add_control('safha_one_page_features_category',array(
		'type'    => 'select',
		'choices' => $cat_posts,
		'label' => __('Select Category to display Latest Post','safha-one-page'),
		'section' => 'safha_one_page_features',
	));

	//no Result Setting
	$wp_customize->add_section('safha_one_page_no_result_setting',array(
		'title'	=> __('No Results Settings','safha-one-page'),
		'panel' => 'safha_one_page_panel_id',
	));	

	$wp_customize->add_setting('safha_one_page_no_search_result_title',array(
		'default'=> __('Nothing Found','safha-one-page'),
		'sanitize_callback'	=> 'sanitize_text_field'
	));
	$wp_customize->add_control('safha_one_page_no_search_result_title',array(
		'label'	=> __('No Search Results Title','safha-one-page'),
		'section'=> 'safha_one_page_no_result_setting',
		'type'=> 'text'
	));

	$wp_customize->add_setting('safha_one_page_no_search_result_content',array(
		'default'=> __('Sorry, but nothing matched your search terms. Please try again with some different keywords.','safha-one-page'),
		'sanitize_callback'	=> 'sanitize_text_field'
	));
	$wp_customize->add_control('safha_one_page_no_search_result_content',array(
		'label'	=> __('No Search Results Content','safha-one-page'),
		'section'=> 'safha_one_page_no_result_setting',
		'type'=> 'text'
	));

	 //404 Page Setting
	$wp_customize->add_section('safha_one_page_page_not_found_setting',array(
		'title'	=> __('Page Not Found Settings','safha-one-page'),
		'panel' => 'safha_one_page_panel_id',
	));	

	$wp_customize->add_setting('safha_one_page_page_not_found_title',array(
		'default'=> '',
		'sanitize_callback'	=> 'sanitize_text_field'
	));
	$wp_customize->add_control('safha_one_page_page_not_found_title',array(
		'label'	=> __('Page Not Found Title','safha-one-page'),
		'section'=> 'safha_one_page_page_not_found_setting',
		'type'=> 'text'
	));

	$wp_customize->add_setting('safha_one_page_page_not_found_content',array(
		'default'=> '',
		'sanitize_callback'	=> 'sanitize_text_field'
	));
	$wp_customize->add_control('safha_one_page_page_not_found_content',array(
		'label'	=> __('Page Not Found Content','safha-one-page'),
		'section'=> 'safha_one_page_page_not_found_setting',
		'type'=> 'text'
	));

	//Responsive Media Settings
	$wp_customize->add_section('safha_one_page_mobile_media',array(
		'title'	=> __('Mobile Media Settings','safha-one-page'),
		'panel' => 'safha_one_page_panel_id',
	));

	$wp_customize->add_setting('safha_one_page_enable_disable_preloader',array(
       'default' => false,
       'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
    ));
    $wp_customize->add_control('safha_one_page_enable_disable_preloader',array(
       'type' => 'checkbox',
       'label' => __('Enable / Disable Preloader','safha-one-page'),
       'section' => 'safha_one_page_mobile_media'
    ));

	$wp_customize->add_setting('safha_one_page_enable_disable_sidebar',array(
       'default' => true,
       'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
    ));
    $wp_customize->add_control('safha_one_page_enable_disable_sidebar',array(
       'type' => 'checkbox',
       'label' => __('Enable / Disable Sidebar','safha-one-page'),
       'section' => 'safha_one_page_mobile_media'
    ));

	$wp_customize->add_setting('safha_one_page_enable_disable_topbar',array(
       'default' => false,
       'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
    ));
    $wp_customize->add_control('safha_one_page_enable_disable_topbar',array(
       'type' => 'checkbox',
       'label' => __('Enable / Disable Top Header','safha-one-page'),
       'section' => 'safha_one_page_mobile_media'
    ));

    $wp_customize->add_setting('safha_one_page_enable_disable_fixed_header',array(
       'default' => false,
       'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
    ));
    $wp_customize->add_control('safha_one_page_enable_disable_fixed_header',array(
       'type' => 'checkbox',
       'label' => __('Enable / Disable Fixed Header','safha-one-page'),
       'section' => 'safha_one_page_mobile_media'
    ));

    $wp_customize->add_setting('safha_one_page_enable_disable_slider',array(
       'default' => false,
       'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
    ));
    $wp_customize->add_control('safha_one_page_enable_disable_slider',array(
       'type' => 'checkbox',
       'label' => __('Enable / Disable Slider','safha-one-page'),
       'section' => 'safha_one_page_mobile_media'
    ));

    $wp_customize->add_setting('safha_one_page_show_hide_slider_button',array(
       'default' => true,
       'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
    ));
    $wp_customize->add_control('safha_one_page_show_hide_slider_button',array(
       'type' => 'checkbox',
       'label' => __('Enable / Disable Slider Button','safha-one-page'),
       'section' => 'safha_one_page_mobile_media'
    ));

    $wp_customize->add_setting('safha_one_page_enable_disable_scrolltop',array(
       'default' => false,
       'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
    ));
    $wp_customize->add_control('safha_one_page_enable_disable_scrolltop',array(
       'type' => 'checkbox',
       'label' => __('Enable / Disable Scroll To Top','safha-one-page'),
       'section' => 'safha_one_page_mobile_media'
    ));

	//Blog Post
	$wp_customize->add_section('safha_one_page_blog_post',array(
		'title'	=> __('Post Settings','safha-one-page'),
		'panel' => 'safha_one_page_panel_id',
	));	

	$wp_customize->add_setting('safha_one_page_date_hide',array(
       'default' => true,
       'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
    ));
    $wp_customize->add_control('safha_one_page_date_hide',array(
       'type' => 'checkbox',
       'label' => __('Post Date','safha-one-page'),
       'section' => 'safha_one_page_blog_post'
    ));

    $wp_customize->add_setting('safha_one_page_post_date_icon_changer',array(
		'default'	=> 'fa fa-calendar',
		'sanitize_callback'	=> 'sanitize_text_field'
	));	
	$wp_customize->add_control(new safha_one_page_Icon_Changer(
        $wp_customize,'safha_one_page_post_date_icon_changer',array(
		'label'	=> __('Post Date Icon','safha-one-page'),
		'transport' => 'refresh',
		'section'	=> 'safha_one_page_blog_post',
		'type'		=> 'icon'
	)));

    $wp_customize->add_setting('safha_one_page_author_hide',array(
       'default' => true,
       'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
    ));
    $wp_customize->add_control('safha_one_page_author_hide',array(
       'type' => 'checkbox',
       'label' => __('Post Author','safha-one-page'),
       'section' => 'safha_one_page_blog_post'
    ));

    $wp_customize->add_setting('safha_one_page_post_author_icon_changer',array(
		'default'	=> 'fa fa-user',
		'sanitize_callback'	=> 'sanitize_text_field'
	));	
	$wp_customize->add_control(new safha_one_page_Icon_Changer(
        $wp_customize,'safha_one_page_post_author_icon_changer',array(
		'label'	=> __('Post Author Icon','safha-one-page'),
		'transport' => 'refresh',
		'section'	=> 'safha_one_page_blog_post',
		'type'		=> 'icon'
	)));

    $wp_customize->add_setting('safha_one_page_comment_hide',array(
       'default' => true,
       'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
    ));
    $wp_customize->add_control('safha_one_page_comment_hide',array(
       'type' => 'checkbox',
       'label' => __('Post Comments','safha-one-page'),
       'section' => 'safha_one_page_blog_post'
    ));

    $wp_customize->add_setting('safha_one_page_post_comment_icon_changer',array(
		'default'	=> 'fas fa-comments',
		'sanitize_callback'	=> 'sanitize_text_field'
	));	
	$wp_customize->add_control(new safha_one_page_Icon_Changer(
        $wp_customize,'safha_one_page_post_comment_icon_changer',array(
		'label'	=> __('Post Comments Icon','safha-one-page'),
		'transport' => 'refresh',
		'section'	=> 'safha_one_page_blog_post',
		'type'		=> 'icon'
	)));

	$wp_customize->add_setting('safha_one_page_post_time_show',array(
       'default' => false,
       'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
    ));
    $wp_customize->add_control('safha_one_page_post_time_show',array(
       'type' => 'checkbox',
       'label' => __('Time','safha-one-page'),
       'section' => 'safha_one_page_blog_post'
    ));

    $wp_customize->add_setting( 'safha_one_page_blog_post_metabox_seperator', array(
		'default'   => '',
		'sanitize_callback'	=> 'sanitize_text_field'
	) );
	$wp_customize->add_control( 'safha_one_page_blog_post_metabox_seperator', array(
		'label'       => esc_html__( 'Blog Post Meta Box Seperator','safha-one-page' ),
		'section'     => 'safha_one_page_blog_post',
		'description' => __('Add the seperator for meta box. Example: ",",  "|", "/", etc. ','safha-one-page'),
		'type'        => 'text',
		'settings'    => 'safha_one_page_blog_post_metabox_seperator',
	) );
    
    $wp_customize->add_setting('safha_one_page_blog_post_layout',array(
        'default' => 'Default',
        'sanitize_callback' => 'safha_one_page_sanitize_choices'
    ));
    $wp_customize->add_control('safha_one_page_blog_post_layout',array(
        'type' => 'radio',
        'label' => __('Post Layout Option','safha-one-page'),
        'section' => 'safha_one_page_blog_post',
        'choices' => array(
            'Default' => __('Default','safha-one-page'),
            'Center' => __('Center','safha-one-page'),
            'Image and Content' => __('Image and Content','safha-one-page'),
        ),
	) );

	$wp_customize->add_setting('safha_one_page_post_break_block_setting',array(
        'default' => 'Into Blocks',
        'sanitize_callback' => 'safha_one_page_sanitize_choices'
	));
	$wp_customize->add_control('safha_one_page_post_break_block_setting',array(
        'type' => 'radio',
        'label' => __('Display Blog Page posts','safha-one-page'),
        'section' => 'safha_one_page_blog_post',
        'choices' => array(
            'Into Blocks' => __('Into Blocks','safha-one-page'),
            'Without Blocks' => __('Without Blocks','safha-one-page'),
        ),
	) );

	$wp_customize->add_setting('safha_one_page_post_image_dimention',array(
       'default' => 'Default',
       'sanitize_callback'	=> 'safha_one_page_sanitize_choices'
    ));
    $wp_customize->add_control('safha_one_page_post_image_dimention',array(
       'type' => 'radio',
       'label'	=> __('Post Featured Image Dimention','safha-one-page'),
       'choices' => array(
            'Default' => __('Default','safha-one-page'),
            'Custom Image Size' => __('Custom Image Size','safha-one-page'),
        ),
      	'section'	=> 'safha_one_page_blog_post'
    ));

    $wp_customize->add_setting( 'safha_one_page_post_featured_image_width',array(
		'default' => '',
		'sanitize_callback'	=> 'safha_one_page_sanitize_number_range'
	));
	$wp_customize->add_control('safha_one_page_post_featured_image_width',	array(
		'label' => esc_html__( 'Blog Post Custom Width','safha-one-page' ),
		'section' => 'safha_one_page_blog_post',
		'input_attrs' => array(
			'min' => 0,
			'max' => 500,
			'step' => 1,
		),
		'type' => 'range',
		'active_callback' => 'safha_one_page_enable_image_dimention'
	));

	$wp_customize->add_setting( 'safha_one_page_post_featured_image_height',array(
		'default' => '',
		'sanitize_callback'	=> 'safha_one_page_sanitize_number_range'
	));
	$wp_customize->add_control('safha_one_page_post_featured_image_height',	array(
		'label' => esc_html__( 'Blog Post Custom Height','safha-one-page' ),
		'section' => 'safha_one_page_blog_post',
		'input_attrs' => array(
			'min' => 0,
			'max' => 350,
			'step' => 1,
		),
		'type' => 'range',
		'active_callback' => 'safha_one_page_enable_image_dimention'
	));

	$wp_customize->add_setting('safha_one_page_blog_description',array(
    	'default'   => 'Post Excerpt',
        'sanitize_callback' => 'safha_one_page_sanitize_choices'
	));
	$wp_customize->add_control('safha_one_page_blog_description',array(
        'type' => 'select',
        'label' => __('Post Description','safha-one-page'),
        'section' => 'safha_one_page_blog_post',
        'choices' => array(
            'None' => __('None','safha-one-page'),
            'Post Excerpt' => __('Post Excerpt','safha-one-page'),
            'Post Content' => __('Post Content','safha-one-page'),
        ),
	) );

    $wp_customize->add_setting( 'safha_one_page_excerpt_number', array(
		'default'              => 20,
		'sanitize_callback'	=> 'safha_one_page_sanitize_float',
	) );
	$wp_customize->add_control( 'safha_one_page_excerpt_number', array(
		'label'       => esc_html__( 'Excerpt length','safha-one-page' ),
		'section'     => 'safha_one_page_blog_post',
		'type'        => 'number',
		'settings'    => 'safha_one_page_excerpt_number',
		'input_attrs' => array(
			'step'             => 2,
			'min'              => 0,
			'max'              => 50,
		),
	) );

	$wp_customize->add_setting( 'safha_one_page_post_excerpt_suffix', array(
		'default'   => __('{...}','safha-one-page'),
		'sanitize_callback'	=> 'sanitize_text_field'
	) );
	$wp_customize->add_control( 'safha_one_page_post_excerpt_suffix', array(
		'label'       => esc_html__( 'Excerpt Indicator','safha-one-page' ),
		'section'     => 'safha_one_page_blog_post',
		'type'        => 'text',
		'settings'    => 'safha_one_page_post_excerpt_suffix',
	) );

	$wp_customize->add_setting('safha_one_page_button_text',array(
		'default'=> __('READ MORE','safha-one-page'),
		'sanitize_callback'	=> 'sanitize_text_field'
	));
	$wp_customize->add_control('safha_one_page_button_text',array(
		'label'	=> __('Add Button Text','safha-one-page'),
		'section'=> 'safha_one_page_blog_post',
		'type'=> 'text'
	));

	$wp_customize->add_setting('safha_one_page_show_post_pagination',array(
       'default' => true,
       'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
    ));
    $wp_customize->add_control('safha_one_page_show_post_pagination',array(
       'type' => 'checkbox',
       'label' => __('Post Pagination','safha-one-page'),
       'section' => 'safha_one_page_blog_post'
    ));

	$wp_customize->add_setting( 'safha_one_page_pagination_option', array(
        'default'			=> 'Default',
        'sanitize_callback'	=> 'safha_one_page_sanitize_choices'
    ));
    $wp_customize->add_control( 'safha_one_page_pagination_option', array(
        'section' => 'safha_one_page_blog_post',
        'type' => 'radio',
        'label' => __( 'Post Pagination', 'safha-one-page' ),
        'choices'		=> array(
            'Default'  => __( 'Default', 'safha-one-page' ),
            'next-prev' => __( 'Next / Previous', 'safha-one-page' ),
    )));

 	// Single post setting
    $wp_customize->add_section('safha_one_page_single_post_section',array(
		'title'	=> __('Single Post Settings','safha-one-page'),
		'panel' => 'safha_one_page_panel_id',
	));	

	$wp_customize->add_setting('safha_one_page_tags_hide',array(
       'default' => true,
       'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
    ));
    $wp_customize->add_control('safha_one_page_tags_hide',array(
       'type' => 'checkbox',
       'label' => __('Single Post Tags','safha-one-page'),
       'section' => 'safha_one_page_single_post_section'
    ));

    $wp_customize->add_setting('safha_one_page_single_post_image',array(
       'default' => true,
       'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
    ));
    $wp_customize->add_control('safha_one_page_single_post_image',array(
       'type' => 'checkbox',
       'label' => __('Single Post Featured Image','safha-one-page'),
       'section' => 'safha_one_page_single_post_section'
    ));

    $wp_customize->add_setting('safha_one_page_single_post_date',array(
       'default' => 'true',
       'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
    ));
    $wp_customize->add_control('safha_one_page_single_post_date',array(
       'type' => 'checkbox',
       'label' => __('Single Post Date','safha-one-page'),
       'section' => 'safha_one_page_single_post_section'
    ));

    $wp_customize->add_setting('safha_one_page_single_post_author',array(
       'default' => 'true',
       'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
    ));
    $wp_customize->add_control('safha_one_page_single_post_author',array(
       'type' => 'checkbox',
       'label' => __('Single Post Author','safha-one-page'),
       'section' => 'safha_one_page_single_post_section'
    ));

    $wp_customize->add_setting('safha_one_page_single_post_comment',array(
       'default' => true,
       'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
    ));
    $wp_customize->add_control('safha_one_page_single_post_comment',array(
       'type' => 'checkbox',
       'label' => __('Single Post Comments','safha-one-page'),
       'section' => 'safha_one_page_single_post_section'
    ));

    $wp_customize->add_setting('safha_one_page_single_post_time',array(
       'default' => false,
       'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
    ));
    $wp_customize->add_control('safha_one_page_single_post_time',array(
       'type' => 'checkbox',
       'label' => __('Single Post Time','safha-one-page'),
       'section' => 'safha_one_page_single_post_section'
    ));

    $wp_customize->add_setting('safha_one_page_show_single_post_pagination',array(
       'default' => true,
       'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
    ));
    $wp_customize->add_control('safha_one_page_show_single_post_pagination',array(
       'type' => 'checkbox',
       'label' => __('Single Post Pagination','safha-one-page'),
       'section' => 'safha_one_page_single_post_section'
    ));

    $wp_customize->add_setting('safha_one_page_show_hide_single_post_categories',array(
		'default' => true,
		'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
 	));
 	$wp_customize->add_control('safha_one_page_show_hide_single_post_categories',array(
		'type' => 'checkbox',
		'label' => __('Single Post Categories','safha-one-page'),
		'section' => 'safha_one_page_single_post_section'
	));

    $wp_customize->add_setting( 'safha_one_page_seperator_metabox', array(
		'default'   => '',
		'sanitize_callback'	=> 'sanitize_text_field'
	) );
	$wp_customize->add_control( 'safha_one_page_seperator_metabox', array(
		'label'       => esc_html__( 'Single Post Meta Box Seperator','safha-one-page' ),
		'section'     => 'safha_one_page_single_post_section',
		'description' => __('Add the seperator for meta box. Example: ",",  "|", "/", etc. ','safha-one-page'),
		'type'        => 'text',
		'settings'    => 'safha_one_page_seperator_metabox',
	) );

	$wp_customize->add_setting('safha_one_page_comment_form_heading',array(
       'default' => __('Leave a Reply','safha-one-page'),
       'sanitize_callback'	=> 'sanitize_text_field'
    ));
    $wp_customize->add_control('safha_one_page_comment_form_heading',array(
       'type' => 'text',
       'label' => __('Comment Form Heading','safha-one-page'),
       'section' => 'safha_one_page_single_post_section'
    ));

    $wp_customize->add_setting('safha_one_page_comment_button_text',array(
       'default' => __('Post Comment','safha-one-page'),
       'sanitize_callback'	=> 'sanitize_text_field'
    ));
    $wp_customize->add_control('safha_one_page_comment_button_text',array(
       'type' => 'text',
       'label' => __('Comment Submit Button Text','safha-one-page'),
       'section' => 'safha_one_page_single_post_section'
    ));

    $wp_customize->add_setting( 'safha_one_page_comment_form_size',array(
		'default' => 100,
		'sanitize_callback' => 'safha_one_page_sanitize_number_range',
	));
	$wp_customize->add_control('safha_one_page_comment_form_size',	array(
		'label' => esc_html__( 'Comment Form Size','safha-one-page' ),
		'section' => 'safha_one_page_single_post_section',
		'type' => 'range',
		'input_attrs' => array(
			'min' => 0,
			'max' => 100,
			'step' => 1,
		),
	));

    // related post setting
    $wp_customize->add_section('safha_one_page_related_post_section',array(
		'title'	=> __('Related Post Settings','safha-one-page'),
		'panel' => 'safha_one_page_panel_id',
	));	

	$wp_customize->add_setting('safha_one_page_related_posts',array(
       'default' => true,
       'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
    ));
    $wp_customize->add_control('safha_one_page_related_posts',array(
       'type' => 'checkbox',
       'label' => __('Related Post','safha-one-page'),
       'section' => 'safha_one_page_related_post_section',
    ));

	$wp_customize->add_setting( 'safha_one_page_show_related_post', array(
        'default' => 'By Categories',
        'sanitize_callback'	=> 'safha_one_page_sanitize_choices'
    ));
    $wp_customize->add_control( 'safha_one_page_show_related_post', array(
        'section' => 'safha_one_page_related_post_section',
        'type' => 'radio',
        'label' => __( 'Show Related Posts', 'safha-one-page' ),
        'choices' => array(
            'categories'  => __('By Categories', 'safha-one-page'),
            'tags' => __( 'By Tags', 'safha-one-page' ),
    )));

    $wp_customize->add_setting('safha_one_page_change_related_post_title',array(
		'default'=> __('Related Posts','safha-one-page'),
		'sanitize_callback'	=> 'sanitize_text_field'
	));
	$wp_customize->add_control('safha_one_page_change_related_post_title',array(
		'label'	=> __('Change Related Post Title','safha-one-page'),
		'section'=> 'safha_one_page_related_post_section',
		'type'=> 'text'
	));

   	$wp_customize->add_setting('safha_one_page_change_related_posts_number',array(
		'default'=> 3,
		'sanitize_callback'	=> 'safha_one_page_sanitize_float',
	));
	$wp_customize->add_control('safha_one_page_change_related_posts_number',array(
		'label'	=> __('Change Related Post Number','safha-one-page'),
		'section'=> 'safha_one_page_related_post_section',
		'type'=> 'number',
		'input_attrs' => array(
            'step'             => 1,
			'min'              => 0,
			'max'              => 50,
        ),
	));

	//Footer
	$wp_customize->add_section( 'safha_one_page_footer' , array(
    	'title'   => __( 'Footer Section', 'safha-one-page' ),
		'panel' => 'safha_one_page_panel_id'
	) );

	$wp_customize->add_setting('safha_one_page_footer_widget',array(
        'default'           => 4,
        'sanitize_callback' => 'safha_one_page_sanitize_choices',
    ));
    $wp_customize->add_control('safha_one_page_footer_widget',array(
        'type'        => 'radio',
        'label'       => __('No. of Footer widget area', 'safha-one-page'),
        'section'     => 'safha_one_page_footer',
        'description' => __('Select the number of footer widget areas and after that, go to Appearance > Widgets and add your widgets in the footer.', 'safha-one-page'),
        'choices' => array(
            '1'     => __('One', 'safha-one-page'),
            '2'     => __('Two', 'safha-one-page'),
            '3'     => __('Three', 'safha-one-page'),
            '4'     => __('Four', 'safha-one-page')
        ),
    ));

    $wp_customize->add_setting( 'safha_one_page_footer_widget_background', array(
	    'default' => '#01305c',
	    'sanitize_callback' => 'sanitize_hex_color'
  	));
  	$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'safha_one_page_footer_widget_background', array(
  		'label' => __('Footer Widget Background','safha-one-page'),
	    'section' => 'safha_one_page_footer',
  	)));

  	$wp_customize->add_setting('safha_one_page_footer_widget_image',array(
		'default'	=> '',
		'sanitize_callback'	=> 'esc_url_raw',
	));
	$wp_customize->add_control( new WP_Customize_Image_Control($wp_customize,'safha_one_page_footer_widget_image',array(
        'label' => __('Footer Widget Background Image','safha-one-page'),
        'section' => 'safha_one_page_footer'
	)));

	$wp_customize->add_setting('safha_one_page_hide_show_scroll',array(
        'default' => false,
        'sanitize_callback'	=> 'safha_one_page_sanitize_checkbox'
	));
	$wp_customize->add_control('safha_one_page_hide_show_scroll',array(
     	'type' => 'checkbox',
      	'label' => __('Show / Hide Scroll To Top','safha-one-page'),
      	'section' => 'safha_one_page_footer',
	));

	$wp_customize->add_setting('safha_one_page_scroll_icon_changer',array(
		'default'	=> 'fas fa-long-arrow-alt-up',
		'sanitize_callback'	=> 'sanitize_text_field'
	));	
	$wp_customize->add_control(new safha_one_page_Icon_Changer(
        $wp_customize,'safha_one_page_scroll_icon_changer',array(
		'label'	=> __('Scroll To Top Icon','safha-one-page'),
		'transport' => 'refresh',
		'section'	=> 'safha_one_page_footer',
		'type'		=> 'icon'
	)));

	$wp_customize->add_setting('safha_one_page_footer_options',array(
        'default' => 'Right align',
        'sanitize_callback' => 'safha_one_page_sanitize_choices'
	));
	$wp_customize->add_control('safha_one_page_footer_options',array(
        'type' => 'select',
        'label' => __('Scroll To Top','safha-one-page'),
        'description' => __('Here you can change the Footer layout. ','safha-one-page'),
        'section' => 'safha_one_page_footer',
        'choices' => array(
            'Left align' => __('Left align','safha-one-page'),
            'Right align' => __('Right align','safha-one-page'),
            'Center align' => __('Center align','safha-one-page'),
        ),
	) );

	$wp_customize->add_setting('safha_one_page_scroll_top_fontsize',array(
		'default'=> '',
		'sanitize_callback' => 'safha_one_page_sanitize_number_range',
	));
	$wp_customize->add_control('safha_one_page_scroll_top_fontsize',array(
		'label'	=> __('Scroll To Top Font Size','safha-one-page'),
		'input_attrs' => array(
            'step'             => 1,
			'min'              => 0,
			'max'              => 50,
        ),
		'section'=> 'safha_one_page_footer',
		'type'=> 'range'
	));

	$wp_customize->add_setting('safha_one_page_scroll_top_bottom_padding',array(
		'default'=> '',
		'sanitize_callback'	=> 'safha_one_page_sanitize_float',
	));
	$wp_customize->add_control('safha_one_page_scroll_top_bottom_padding',array(
		'label'	=> __('Scroll Top Bottom Padding ','safha-one-page'),
		'input_attrs' => array(
            'step'             => 1,
			'min'              => 0,
			'max'              => 50,
        ),
		'section'=> 'safha_one_page_footer',
		'type'=> 'number'
	));

	$wp_customize->add_setting('safha_one_page_scroll_left_right_padding',array(
		'default'=> '',
		'sanitize_callback'	=> 'safha_one_page_sanitize_float',
	));
	$wp_customize->add_control('safha_one_page_scroll_left_right_padding',array(
		'label'	=> __('Scroll Left Right Padding','safha-one-page'),
		'input_attrs' => array(
            'step'             => 1,
			'min'              => 0,
			'max'              => 50,
        ),
		'section'=> 'safha_one_page_footer',
		'type'=> 'number'
	));

	$wp_customize->add_setting( 'safha_one_page_scroll_border_radius', array(
		'default'=> '',
		'sanitize_callback'	=> 'safha_one_page_sanitize_float',
	) );
	$wp_customize->add_control( 'safha_one_page_scroll_border_radius', array(
		'label'       => esc_html__( 'Scroll To Top Border Radius','safha-one-page' ),
		'section'     => 'safha_one_page_footer',
		'type'        => 'number',
		'input_attrs' => array(
			'step'             => 1,
			'min'              => 0,
			'max'              => 50,
		),
	) );

	$wp_customize->add_setting('safha_one_page_footer_text',array(
		'default'	=> '',
		'sanitize_callback'	=> 'sanitize_text_field'
	));	
	$wp_customize->add_control('safha_one_page_footer_text',array(
		'label'	=> __('Add Copyright Text','safha-one-page'),
		'section'	=> 'safha_one_page_footer',
		'setting'	=> 'safha_one_page_footer_text',
		'type'		=> 'text'
	));

	$wp_customize->add_setting('safha_one_page_copyright_top_bottom_padding',array(
		'default'=> '',
		'sanitize_callback'	=> 'safha_one_page_sanitize_float',
	));
	$wp_customize->add_control('safha_one_page_copyright_top_bottom_padding',array(
		'label'	=> __('Copyright Top and Bottom Padding','safha-one-page'),
		'input_attrs' => array(
            'step'             => 1,
			'min'              => 0,
			'max'              => 50,
        ),
		'section'=> 'safha_one_page_footer',
		'type'=> 'number'
	));

	$wp_customize->add_setting('safha_one_page_copyright_background_color', array(
		'default'           => '#00c7fe',
		'sanitize_callback' => 'sanitize_hex_color',
	));
	$wp_customize->add_control(new WP_Customize_Color_Control($wp_customize, 'safha_one_page_copyright_background_color', array(
		'label'    => __('Copyright Background Color', 'safha-one-page'),
		'section'  => 'safha_one_page_footer',
	)));

	$wp_customize->add_setting('safha_one_page_footer_text_font_size',array(
		'default'=> 16,
		'sanitize_callback'    => 'safha_one_page_sanitize_float',
	));
	$wp_customize->add_control('safha_one_page_footer_text_font_size',array(
		'label'	=> __('Footer Text Font Size','safha-one-page'),
		'section'=> 'safha_one_page_footer',
		'input_attrs' => array(
            'step'             => 1,
			'min'              => 0,
			'max'              => 50,
        ),
		'type'=> 'number'
	));

	$wp_customize->get_setting( 'blogname' )->transport          = 'postMessage';
	$wp_customize->get_setting( 'blogdescription' )->transport   = 'postMessage';
	$wp_customize->get_setting( 'header_textcolor' )->transport  = 'postMessage';

	$wp_customize->selective_refresh->add_partial( 'blogname', array(
		'selector' => '.site-title a',
		'render_callback' => 'safha_one_page_customize_partial_blogname',
	) );
	$wp_customize->selective_refresh->add_partial( 'blogdescription', array(
		'selector' => '.site-description',
		'render_callback' => 'safha_one_page_customize_partial_blogdescription',
	) );
	
}
add_action( 'customize_register', 'safha_one_page_customize_register' );

// logo resize
load_template( trailingslashit( get_template_directory() ) . '/inc/logo/logo-resizer.php' );

/**
 * Render the site title for the selective refresh partial.
 *
 * @since Safha One Page 1.0
 * @see safha-one-page_customize_register()
 *
 * @return void
 */
function safha_one_page_customize_partial_blogname() {
	bloginfo( 'name' );
}

/**
 * Render the site tagline for the selective refresh partial.
 *
 * @since Safha One Page 1.0
 * @see safha-one-page_customize_register()
 *
 * @return void
 */
function safha_one_page_customize_partial_blogdescription() {
	bloginfo( 'description' );
}

/**
 * Return whether we're on a view that supports a one or two column layout.
 */
function safha_one_page_is_view_with_layout_option() {
	// This option is available on all pages. It's also available on archives when there isn't a sidebar.
	return ( is_page() || ( is_archive() && ! is_active_sidebar( 'footer-1' ) ) );
}

/**
 * Singleton class for handling the theme's customizer integration.
 *
 * @since  1.0.0
 * @access public
 */
final class Safha_One_Page_Customize {

	/**
	 * Returns the instance.
	 *
	 * @since  1.0.0
	 * @access public
	 * @return object
	 */
	public static function get_instance() {

		static $instance = null;

		if ( is_null( $instance ) ) {
			$instance = new self;
			$instance->setup_actions();
		}

		return $instance;
	}

	/**
	 * Constructor method.
	 *
	 * @since  1.0.0
	 * @access private
	 * @return void
	 */
	private function __construct() {}

	/**
	 * Sets up initial actions.
	 *
	 * @since  1.0.0
	 * @access private
	 * @return void
	 */
	private function setup_actions() {

		// Register panels, sections, settings, controls, and partials.
		add_action( 'customize_register', array( $this, 'sections' ) );

		// Register scripts and styles for the controls.
		add_action( 'customize_controls_enqueue_scripts', array( $this, 'enqueue_control_scripts' ), 0 );
	}

	/**
	 * Sets up the customizer sections.
	 *
	 * @since  1.0.0
	 * @access public
	 * @param  object  $manager
	 * @return void
	 */
	public function sections( $manager ) {

		// Load custom sections.
		load_template( trailingslashit( get_template_directory() ) . '/inc/section-pro.php' );

		// Register custom section types.
		$manager->register_section_type( 'Safha_One_Page_Customize_Section_Pro' );

		// Register sections.
		$manager->add_section(
			new Safha_One_Page_Customize_Section_Pro(
				$manager,
				'safha_one_page_example_1',
				array(
					'priority' => 9,
					'title'    => esc_html__( 'Safha One Page Pro', 'safha-one-page' ),
					'pro_text' => esc_html__( 'Go Pro', 'safha-one-page' ),
					'pro_url'  => esc_url('https://www.themeseye.com/wordpress/one-page-wordpress-theme/'),
				)
			)
		);
	}

	/**
	 * Loads theme customizer CSS.
	 *
	 * @since  1.0.0
	 * @access public
	 * @return void
	 */
	public function enqueue_control_scripts() {

		wp_enqueue_script( 'safha-one-page-customize-controls', trailingslashit( esc_url(get_template_directory_uri()) ) . '/assets/js/customize-controls.js', array( 'customize-controls' ) );

		wp_enqueue_style( 'safha-one-page-customize-controls', trailingslashit( esc_url(get_template_directory_uri()) ) . '/assets/css/customize-controls.css' );
	}
}

// Doing this customizer thang!
Safha_One_Page_Customize::get_instance();